
#include <stdio.h>
#include <stdlib.h>
#include <direct.h>
#include <string.h>
#include <dos.h>

void getdirs( char *, int );
short cursoff( void );
void curson( short );

char    dnum;
int     totsize = 0;
int     totdirs = 0;
int     totfiles = 0;

void main( int argc, char **argv )
{
  unsigned  crap;
  char      lop;
  char      origpath[256];
  char      dirpath[256];
  short     cursstate;

    argv[1] = strupr( argv[1] );

    printf( "\nDirSize v1.0 (C) Mikael Klasson aka Omega\n\n" );

    if( argc < 2 )
    {
        printf( "Usage: DirSize <directory> ; e.g DirSize tmp\n" );
        return;
    }

    cursstate = cursoff();

    getcwd( origpath, 256 );

    if( origpath[strlen( origpath ) - 1] == '\\' ) origpath[strlen( origpath ) - 1] = 0;

    if( argv[1][1] == ':' ) _dos_setdrive( argv[1][0]-'@', &crap );

    if( chdir( argv[1] ) )
    {
        printf( "Unable to open directory \"%s\"!\n", argv[1] );
        return;
    }

    getcwd( dirpath, 256 );

    getdirs( ".", 0 );
    printf( "Directory: %s\n", dirpath );
    printf( "Subdirs:   %d\n", totdirs );
    printf( "Files:     %d\n", totfiles );
    printf( "Size:      %d KB\n", totsize >> 10 );
    curson( cursstate );

    _dos_setdrive( origpath[0]-'@', &crap );
    if( origpath[2] == 0 )
    {
        origpath[2] = '\\';
        origpath[3] = 0;
    }
    chdir( origpath );
    return;
}

#pragma aux cursoff = \
" mov ah,03h "\
" xor bh,bh "\
" int 10h "\
" mov dx,cx "\
" mov ah,01h "\
" mov cx,2000h "\
" int 10h "\
value [dx] modify [ax bx cx dx];


#pragma aux curson = \
" mov ah,01h "\
" int 10h "\
parm [cx] modify [ax cx];


void getdirs( char *dir, int sublevel )
{
  DIR *dirp;
  struct dirent *direntp;
  int lop;

  if( !( dirp = opendir( dir ) ) )
  {
    printf( "Unable to open directory \"%s\"\n", dir );
    exit( 0 );
  }

  chdir( dir );

  for(;;)
  {
    direntp = readdir( dirp );

    if( direntp == NULL ) return;

    if( direntp->d_attr & 0x10 )
    {
        if( strcmp( direntp->d_name, "." ) && strcmp( direntp->d_name, ".." ) )
        {
          totdirs++;
          getdirs( direntp->d_name, sublevel + 1 );
          chdir( ".." );
        }
    }
    else
    {
        totsize += direntp->d_size;
        totfiles++;
    }
  }

  closedir( dirp );

  return;
}

